#include "AlString.h"

// Konstruktoren
AlString::AlString(void)
{
	InnerString = new char[1];
	*InnerString = '\0';
}

AlString::AlString(const char *String)
{
	InnerString = new char[strlen(String) + 1];
	strcpy(InnerString, String);
}

//Methoden
char *AlString::getText()
{
	return InnerString;
}

void AlString::setText(const char *String)
{
	delete InnerString;
	InnerString = new char[strlen(String) + 1];
	strcpy(InnerString, String);
}

size_t AlString::getLength()
{
	return strlen(InnerString);
}

int AlString::compare(AlString String)
{
	return strcmp(InnerString, String.getText());
}

int AlString::compare(const char *String)
{
	return strcmp(InnerString, String);
}

int AlString::toInt()
{
	return atoi(InnerString);
}

long AlString::toLong()
{
	return atol(InnerString);
}

double AlString::toDouble()
{
	return atof(InnerString);
}

// Operatoren
void AlString::operator=(const char *String)
{
	this->setText(String);
}

void AlString::operator=(AlString String)
{
	this->setText(String.getText());
}

void AlString::operator+=(AlString String)
{
	strcat(InnerString, String.getText());
}

void AlString::operator+=(const char *String)
{
	strcat(InnerString, String);
}

bool AlString::operator<(AlString String)
{
	return (this->compare(String) < 0);
}

bool AlString::operator<(const char *String)
{
	return (this->compare(String) < 0);
}

bool AlString::operator>(AlString String)
{
	return (this->compare(String) > 0);
}

bool AlString::operator>(const char *String)
{
	return (this->compare(String) > 0);
}

bool AlString::operator==(AlString String)
{
	return (this->compare(String) == 0);
}

bool AlString::operator==(const char *String)
{
	return (this->compare(String) == 0);
}

bool AlString::operator!=(AlString String)
{
	return (this->compare(String) != 0);
}

bool AlString::operator!=(const char *String)
{
	return (this->compare(String) != 0);
}

AlString AlString::operator+(AlString String)
{
	AlString *NewString = new AlString(InnerString);
	*NewString += String;
	return *NewString;
}

AlString AlString::operator+(const char *String) // fixme
{
	AlString *NewString = new AlString(InnerString);
	*NewString += String;
	return *NewString;
}

ostream& operator<<(ostream& os, AlString String)
{
	os << String.getText();
	return os;
}
